#!/bin/sh

# experimental directory
exp_dir="CH_GERMAN_LCRC_N"

# output directory
out_dir="/net/scratch03/schwarzp/Experiments/CH/$exp_dir/it001"

# enable/disable temporal directory
use_tmp=1

# enable/disable Sun Grid Engine
# Do you use a cluster of computers. If not, disable this option
use_sge=1

# tune phoneme insertion penalty (on CV set) to maximal accuracy, 
# else the equal number of insertion and deletion errors is tuned
tune_max_acc=1

# save output of lower network and do not generate it 
# for each iteration of merger neural network again
save_streams_output=1

# stages that are run
# - mel bank extraction (or other parameterization, depends on parameterization script)
do_param_train=0
do_param_cv=0
do_param_test=0

do_train=1
do_train_streams=1
do_train_merger=1

# forward features 
do_fwd_train=1
do_fwd_cv=1
do_fwd_test=1

# decode posteriors and produce strings
do_decode_train=1
do_decode_cv=1
do_decode_test=1

# scoring
do_score_train=1
do_score_cv=1
do_score_test=1

# trace
trace_streams_normest=1

ts_keep_dec=1
ts_min_iter=5
keep_tmp_files=1

# input directory with lists, reference labels and dictionary
input_dir=/mnt/scratch03/schwarzp/CH/nn/German

# lists of waveform files
train_raw_list=none
test_raw_list=none
cv_raw_list=none

# reference mlf
ref_mlf=$input_dir/mlfs/ref.mlf

# the dictionary
dict=${input_dir}/dicts/dict.txt

# dir with preparametrized speech
fea_dir=none

# pre-parametrization (mel bank generation script)
fea_script=none

# lists of melbanks files
train_fea_list=${input_dir}/lists/train.scp
test_fea_list=${input_dir}/lists/test.scp
cv_fea_list=${input_dir}/lists/cv.scp
lre_fea_list=${input_dir}/lists/train.scp
tune_fea_list=${input_dir}/lists/cv.scp

num_states=1

# streams
streams_start_frame_ext=15
streams_end_frame_ext=15

stream_ipattern[1]="1:[NFEATURES],1:16"
stream_ipattern[2]="1:[NFEATURES],16:31"

stream_iwindow[1]="<WindowPredef> [INPUT_SIZE] LinSpace 0.01 1 [NFEATURES]"
stream_iwindow[2]="<WindowPredef> [INPUT_SIZE] LinSpace 1 0.01 [NFEATURES]"

# macro [NFEATURES]x copies the transform [NFEATURES]x to a parallel structure
stream_itransform[1]="[NFEATURES]x <XformPredef> 11 16 DCT 1"
stream_itransform[2]="[NFEATURES]x <XformPredef> 11 16 DCT 1"

stream_net[1]="<XformPredef> 500 [INPUT_SIZE] Random -0.1 0.1 999; <BiasPredef> 500 Random -4.1 -3.9 999; <Sigmoid> 500;
               <XformPredef> [OUTPUT_SIZE] 500 Random -0.1 0.1 999; <BiasPredef> [OUTPUT_SIZE] Random -4.1 -3.9 999; <SoftMax> [OUTPUT_SIZE]"
        
stream_net[2]="<XformPredef> 500 [INPUT_SIZE] Random -0.1 0.1 999; <BiasPredef> 500 Random -4.1 -3.9 999; <Sigmoid> 500;
               <XformPredef> [OUTPUT_SIZE] 500 Random -0.1 0.1 999; <BiasPredef> [OUTPUT_SIZE] Random -4.1 -3.9 999; <SoftMax> [OUTPUT_SIZE]"

stream_nused_layers[1]=999
stream_nused_layers[2]=999

stream_otransform[1]="<WindowPredef> [INPUT_SIZE] Const 1"
stream_otransform[2]="<WindowPredef> [INPUT_SIZE] Const 1"
#stream_otransform[3]="<WindowPredef> [INPUT_SIZE] Const 1"

stream_ofunc[1]="<Log> [SIZE]"
stream_ofunc[2]="<Log> [SIZE]"

streams_learning_rate=0.008

# merger
merger_start_frame_ext=$streams_start_frame_ext
merger_end_frame_ext=$streams_start_frame_ext

merger_ifunc="<WindowPredef> [SIZE] Const 1"

merger_ipattern="1:[MERGER_NFEATURES],1"

merger_iwindow="<WindowPredef> [INPUT_SIZE] Const 1"

merger_itransform="<WindowPredef> [INPUT_SIZE] Const 1"

merger_net="<XformPredef> 500 [INPUT_SIZE] Random -0.1 0.1 999; <BiasPredef> 500 Random -4.1 -3.9 999; <Sigmoid> 500;
            <XformPredef> [OUTPUT_SIZE] 500 Random -0.1 0.1 999; <BiasPredef> [OUTPUT_SIZE] Random -4.1 -3.9 999; <SoftMax> [OUTPUT_SIZE]"

merger_ofunc="<Log> [SIZE]"

merger_learning_rate=0.008

num_iters=4
num_states=1

sge_computers="all.q@@blade"
sge_fast_computers="all.q@@blade"
sge_resource="tmp_free=5000,disk_free=5000"
