#!/bin/bash

if [ $# -ne 3 ] ; then
  echo USAGE: decode.sh config_file file_list out_mlf
  exit 1
fi

conf=$1
list=$2
omlf=$3

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Decoding '$list' to MLF '$omlf'..."

if [ "$lmscale" = "" ] ; then
  lmscale=1
fi

penalty=`tail -n 1 $out_dir/decoder/wip_tuning.txt`

if [ ! -e "$omlf" ] ; then
  ${bin_dir}/SVite --htkcompat=TRUE -P HTK -S $list -H $out_dir/decoder/hmmdefs -i $omlf -l '*' \
   -s $lmscale -w $out_dir/decoder/phn_loop.lat -p $penalty $out_dir/decoder/lexicon $out_dir/decoder/dict
fi
