#!/bin/sh

if [ $# -ne 2 ] ; then
  echo USAGE: fwd.sh config_file file_list
  exit 1
fi

conf=$1
list=$2

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Evaluating frame accuracy for '$list'..."

#$bin_dir/SFeaCat -T 1 -H $out_dir/weights/full_sys_fwd.ftr -S $list -l $odir

  ${bin_dir}/SNet --crossvalidation=TRUE \
                  --cache-size=${net_train_cache_size:=1200} \
                  --bunch-size=${net_train_bunch_size:=1000} \
                  --learning-rate=0.01 \
                  --randomize=${net_train_randomize:=TRUE} \
                  --seed=${net_train_seed:=0} \
                  --clients=${net_train_clients:=0} \
                  --synchronize=${net_train_synchronize:=TRUE} \
                  --port=${net_train_port:=2020} \
                  --ncumrbu=${net_train_ncumrbu:=0} \
                  --output-label-map=$out_dir/dicts/dict \
                  --start-frm-ext=$streams_start_frame_ext \
                  --end-frm-ext=$streams_end_frame_ext \
                  --source-mlf=$out_dir/mlfs/ref.mlf \
                  --source-mmf="$out_dir/norms/merger_norm.ftr,$out_dir/weights/streams.ftr,$out_dir/weights/merger/final/merger_nn.ftr,$out_dir/macros/merger_train_nn.ftr" \
                  --print-config=TRUE \
                  --trace=1 \
                  --script=$list
                  
