#!/bin/bash

if [ $# -ne 3 ] ; then
  echo USAGE: falign.sh config_file file_list out_mlf
  exit 1
fi

conf=$1
list=$2
omlf=$3

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Force aligning '$list' to MLF '$omlf'..."

if [ "$lmscale" = "" ] ; then
  lmscale=1
fi

if [ ! -e "$omlf" ] ; then
  ${bin_dir}/SVite -t 0 -f --htkcompat=TRUE -P HTK -S $list -H $out_dir/decoder/hmmdefs -i $omlf -l '*' \
   -I $out_dir/mlfs/ref_phn.mlf $out_dir/decoder/lexicon $out_dir/decoder/dict
fi
