#!/bin/sh

if [ $# -ne 3 ] ; then
  echo USAGE: fwd.sh config_file file_list out_dir
  exit 1
fi

conf=$1
list=$2
odir=$3

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Forwarding '$list' to directory '$odir'..."

if [ ! -e $list ] ; then
  echo "ERROR: The list '$list' doesnot exist" > /dev/stderr
  exit 1
fi
if [ `wc $list | awk '{print $1}'` == 0 ] ; then
  echo "ERROR: The list '$list' is empty" > /dev/stderr
  exit 1
fi

mkdir -p $odir

${script_dir}/misc/filterflist.sh $list 1 0 $odir > $out_dir/lists/fwd_fea_flt.scp

$bin_dir/SFeaCat -T 1 \
                 -H $out_dir/weights/full_sys_fwd.ftr \
                 -S $out_dir/lists/fwd_fea_flt.scp \
                 -l $odir \
                 --start-frm-ext=$merger_start_frame_ext \
                 --end-frm-ext=$merger_end_frame_ext

