#!/bin/sh

if [ $# -ne 4 ] ; then
  echo USAGE: fwd_stream.sh config_file stream file_list out_dir
  exit 1
fi

conf=$1
stream_idx=$2
list=$3
odir=$4

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Forwarding '$list' to directory '$odir'..."

mkdir -p $odir
$bin_dir/SFeaCat -T 1 \
                 -H input_mat.ftr \
                 -H stream1.ftr \
                 -H stream1_fwd.ftr \
                 -S $list \
                 -l $odir \
                 --start-frm-ext=$streams_start_frame_ext \
                 --end-frm-ext=$streams_end_frame_ext
                 
