#!/usr/bin/perl

# cut of some last layers in a neural network and keep
# just the first 'n' layers


if($ARGV[0] eq "" || $ARGV[1] eq "")
{
  print STDERR "USAGE: cutoff_layers.pl macro_file n_rem_layers";
  exit 1;
}


$file= $ARGV[0];
$nlayers = $ARGV[1];

open I, $file or die "ERROR: Can not open macro file $file";

$data = "";
$layer=1;
while($l=<I>)
{
  chomp $l;
  if($l =~ /<NumLayers>/)
  {
    ($keyword, $n) = split /\s+/, $l;
    $nlayers = $n if($nlayers > $n);
    $data =~ s/^\n//;
    print "$data\n";
    print "<NumLayers> $nlayers\n";
    $data = "";
  }
  elsif($l =~ /<Layer>/)
  {
    ($keyword, $idx) = split /\s+/, $l;
    if($idx > 1 && $idx <= $nlayers + 1)
    {
      print "<Layer> $layer\n";
      $layer++;
      $data =~ s/^\n//;
      print "$data\n";
      $data = "";  
    }
  }
  else
  {
    $data .= "\n$l";
  }
}

if($layer <= $nlayers)
{
  print "<Layer> $layer\n";
  $data =~ s/^\n//;
  print "$data\n";
}

close I; 

