#!/bin/bash

if [ $# -lt 3 ] ; then
  echo USAGE: fea_filter_p2u.sh fea_nfr_list segment_name_nmodels_list nstates [1-invert-filter]
  exit 1
fi

fea_list=$1
seg_list=$2
nstates=$3
invert_filter=$4

awk 'BEGIN { while(getline < "'$seg_list'") nmodels[$1] = $2;}
           {
             split($1, a, "="); f = a[1]; gsub("\\.[^.]*$", "", f); gsub(".*/", "", f);
             nm = nmodels[f]; nf = $2;
             ratio = nf / ('$nstates' * nm);
             if((ratio >= 1 && "'$invert_filter'" != "1") || (ratio < 1 && "'$invert_filter'" == "1"))
               print $1;
             else if("'$invert_filter'" != "1")
               print "WARNING: Segment '\''" f "'\'' does not have enough frames => was removed from the list." > "/dev/stderr"
           }' $fea_list
