#!/bin/bash

# Very fast selection of nonexisting/existing files from the list 

flist=$1
col=$2
exists=$3
dir="$4"

if [ "$exists" = "" ] ; then
  echo "USAGE: filterflist.sh flist/- column dump_ex_files(1)/dum_notex_files(0) [directory]"
  exit 1
fi

if [ "$flist" = "-" ] ; then
  flist="/dev/stdin"
fi

awk 'BEGIN                   {first=1;}
     NR == FNR               {
                               if("'$dir'" != "")
                               {
                                 dirs["'$dir'"] = 1;
                                 nextfile;
                               }
                               n = split($0, a, " |=");
                               d = a['$col']; gsub("[^/]*$", "", d);
                               dirs[d] = 1;
                             }
     NR != FNR && first == 1 {
                               for(d in dirs)
                               {
                                 cmd = "find " d " -type f 2> /dev/null";
                                 while(cmd | getline f)
                                 {
                                   files[f] = 1;
                                 }
                                 close(cmd);
                               }
                               first = 0;
                             }
     NR != FNR               {
                               n = split($0, a, " |=");
                               f = a['$col']; gsub("\\[.*$", "", f);
                               if("'$dir'" != "")
                               {
                                 gsub(".*/", "", f);
                                 f = "'$dir'/" f;
                               }
                               ex = files[f];
                               if(('$exists' == 1 && ex == "1") || ('$exists' == 0 && ex == ""))
                                 print $0;
                             }' $flist $flist 
