#!/usr/bin/perl

# Gets number of values in the ranges
# The format of ranges is: row1_from:row1_step:row1_to:col1_from:col1_step:col1_to row2_from ...

if($ARGV[0] eq "")
{
	print "SYNTAX: getnvals.pl range1 range2\n";
	exit(1);
}

@ranges = @ARGV;
$sum=0;
$nr=0;

foreach $r (@ranges)
{
  ($row_range, $col_range) = split /,/, $r;

  ($from_r, $step_r, $to_r) = split /:/, $row_range;
  if($from_r eq "")     # range is ,YY or ""
  {
    $from_r = 1;
    $step_r = 1;
    $to_r = 1;
  }
  elsif($step_r eq "")  # range is from,YY
  {
    $step_r = 1;
    $to_r = $from_r; 
  }
  elsif($to_r eq "")    # range is from:to,YY
  {
    $to_r = $step_r;
    $step_r = 1;
  }
  
  ($from_c, $step_c, $to_c) = split /:/, $col_range;
  if($from_c eq "")     # range is XX or XX,
  {
    $from_c = 1;
    $step_c = 1;
    $to_c = 1;
  }
  elsif($step_c eq "")  # range is XX,from
  {
    $step_c = 1;
    $to_c = $from_c;
  }
  elsif($to_c eq "")    # range is XX,from:to
  {
    $to_c = $step_c;
    $step_c = 1;
  }
  
  for($i = $from_r; $i <= $to_r; $i += $step_r)
  {
    for($j = $from_c; $j <= $to_c; $j += $step_c)
    {
      $sum++;
    }
  }
  $nr++;
}

print "$sum $nr\n";
