#!/usr/bin/perl

if($ARGV[0] eq "")
{
  print "\nUSAGE split_labels_dict.pl [options] dict\n\n";
  print "-n num   number of states\n";
  print "-f file  state file (label and number_of_states per line)\n\n";
  exit 1;
}

$num_states=3;
$num_states_file="";
$dict="";

$i = 0;
while($ARGV[$i] ne "")
{
  if($ARGV[$i] eq "-n")
  {
    $i++;
    $num_states = $ARGV[$i];
  }
  elsif($ARGV[$i] eq "-f")
  {
    $i++;
    $num_states_file = $ARGV[$i];
  }
  else
  {
    $dict = $ARGV[$i];
    break;
  }
  $i++;
}

if($dict eq "")
{
  printf STDERR "ERROR: Missing input dictionary\n";
  exit 1;
}

if($num_states_file ne "")
{
  open NSF, $num_states_file or die "ERROR: Can not open '$num_states_file'";
  while($l = <NSF>)
  {
    chomp $l;
    ($lab, $n) = split /\s+/, $l;
#    print "|$lab|$n|\n";
    $nst{$lab} = $n;
  }
  close NFS;
}

open D, $dict or die "ERROR: Can not open input dictionary '$dict'";

while($l = <D>)
{
  chomp $l;
  if($num_states_file ne "")
  {
    $n = $nst{$l};
    if($n == "")
    {
      $n = $num_states;
      print STDERR "WARNING: Label '$label' is not in the '$num_states_file' file => using default value '$num_states' states for splitting\n";
    }
  }
  else
  {
    $n = $num_states;
  }

  for($i = 0; $i < $n; $i++)
  {
    $state=$i + 2;    
    print "${l}__$state\n";
  }
}
close D;

