#!/usr/bin/perl

if($ARGV[0] eq "")
{
  print "\nUSAGE split_labels_mlf.pl [options] mlf\n\n";
  print "-n num   number of states\n";
  print "-f file  state file (label and number_of_states per line)\n\n";
  exit 1;
}

$num_states=3;
$num_states_file="";
$mlf="";

$i = 0;
while($ARGV[$i] ne "")
{
  if($ARGV[$i] eq "-n")
  {
    $i++;
    $num_states = $ARGV[$i];
  }
  elsif($ARGV[$i] eq "-f")
  {
    $i++;
    $num_states_file = $ARGV[$i];
  }
  else
  {
    $mlf = $ARGV[$i];
    break;
  }
  $i++;
}

if($mlf eq "")
{
  printf STDERR "ERROR: Missing input MLF\n";
  exit 1;
}

if($num_states_file ne "")
{
  open NSF, $num_states_file or die "ERROR: Can not open '$num_states_file'";
  while($l = <NSF>)
  {
    chomp $l;
    ($lab, $n) = split /\s+/, $l;
    $nst{$lab} = $n;
  }
  close NFS;
}

open L, $mlf or die "ERROR: Can not open MLF '$mlf'";

$l = <L>;
chomp $l;
die "ERROR: Invalid format of MLF '$MLF'" if($l ne "#!MLF!#");
print "#!MLF!#\n";

while($l = <L>)
{
  print $l;
  do
  {
    $l = <L>;
    chomp $l;
    if($l ne ".")
    {
      ($start, $end, $label, $score) = split /\s/, $l;
      if($num_states_file ne "")
      {
        $n = $nst{$label};
        if($n == "")
        {
          $n = $num_states;
          print STDERR "WARNING: Label '$label' is not in the '$num_states_file' file => using default value '$num_states' states for splitting\n";
        }
      }
      else
      {
        $n = $num_states;
      }
      $delta = ($end - $start) / $n;
      for($i = 0; $i < $n; $i ++)
      {
        $lstart = $start + $i * $delta;
        $lend = $lstart + $delta;
	
	$sstart = int($lstart + .5);
	$send = int($lend + .5);
	
        $state = $i + 2;
        print "$sstart $send ${label}__$state\n";
      }
    }
  } while($l ne ".");
  print ".\n";
}
close L;

