#!/usr/bin/perl

if($ARGV[0] eq "" || $ARGV[1] eq "" || $ARGV[2] eq "" || $ARGV[3] eq "" || $ARGV[4] eq "" || $ARGV[5] eq "" || $ARGV[6] eq "" || $ARGV[7] eq "" || $ARGV[8] eq "")
{
	print "SYNTAX: tunepenalty.pl min max work_directory list mlf phoneme_list lexicon net lm_scale [bin_dir]\n";
	exit(1);
}

$min = $ARGV[0];
$max = $ARGV[1];
$dir = $ARGV[2];
$list = $ARGV[3];
$mlf = $ARGV[4];
$list_phoneme = $ARGV[5];
$lexicon = $ARGV[6];
$net = $ARGV[7];
$lmscale = $ARGV[8];
$bin_dir="$ARGV[9]/";


$x = ($max + $min) / 2;
$delta = ($max - $min) / 4;
$pacc = 9999;
$max_iter=100;
$iter=0;

sub itter
{
	$pen = $_[0];
	printf "Trying %3.6f ... ", $pen;
	system("rm -f $dir/cv.mlf");
	$comm = "${bin_dir}SVite --htkcompat=TRUE -P HTK -S $list -H ${dir}/hmmdefs -i $dir/cv.mlf -l '*' -s $lmscale -w $net -p $pen $lexicon $list_phoneme";
	system($comm);
	
	system("rm -f $dir/cv.txt");
	$comm = "${bin_dir}HResults -I $mlf $list_phoneme $dir/cv.mlf > $dir/cv.txt";
        system($comm);
	
	open R, "$dir/cv.txt" or die "Can not open $dir/cv.txt";

	$acc = -1;
	while($l = <R>)
	{
		chomp $l;
		if($l =~ /Acc=(.+) \[/)
		{
			$acc = $1;
                        $line = $l;
		}
	}

	close R;
	
	print "$acc    $line\n";
	
	return $acc;
}

#$acc_max = itter($max);
#$acc_min = itter($min);

$a = -9999;
$pa = -9999;

do
{
	$pa = $a;
	#$a = itter($x);
	$a1 = itter($x + $delta);
	$a2 = itter($x - $delta);
	if($a1 > $a2)
	{
		$x += $delta;
		$a = $a1;
	}
	else
	{
		$x -= $delta;
		$a = $a2;
	}
	$delta /= 2;
} while(abs($pa - $a) > 0.02);

print "Penalty=$x\n";
print "$x\n";
