#!/bin/bash

if [ $# -ne 2 ] ; then
  echo USAGE: score_mlf.sh config_file mlf
  exit 1
fi

conf=$1
mlf=$2

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf
out_dir=`echo "$out_dir" | awk --posix '/\/it[0-9]{3}*/ {print; next;} {print $1 "/it001";}'`
source $out_dir/config/params.sh

echo "Scoring MLF '$mlf' ..."

${bin_dir}/HResults -p -I $out_dir/decoder/ref.mlf $out_dir/decoder/dict $mlf
